<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditaSerieContrato StructType
 * @subpackage Structs
 */
class EditaSerieContrato extends AbstractStructBase
{
    /**
     * The tipodoc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $tipodoc;
    /**
     * The serie
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $serie;
    /**
     * The forceRefresh
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $forceRefresh;
    /**
     * Constructor method for EditaSerieContrato
     * @uses EditaSerieContrato::setTipodoc()
     * @uses EditaSerieContrato::setSerie()
     * @uses EditaSerieContrato::setForceRefresh()
     * @param string $tipodoc
     * @param string $serie
     * @param bool $forceRefresh
     */
    public function __construct($tipodoc = null, $serie = null, $forceRefresh = null)
    {
        $this
            ->setTipodoc($tipodoc)
            ->setSerie($serie)
            ->setForceRefresh($forceRefresh);
    }
    /**
     * Get tipodoc value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipodoc()
    {
        return isset($this->tipodoc) ? $this->tipodoc : null;
    }
    /**
     * Set tipodoc value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipodoc
     * @return \StructType\EditaSerieContrato
     */
    public function setTipodoc($tipodoc = null)
    {
        // validation for constraint: string
        if (!is_null($tipodoc) && !is_string($tipodoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tipodoc)), __LINE__);
        }
        if (is_null($tipodoc) || (is_array($tipodoc) && empty($tipodoc))) {
            unset($this->tipodoc);
        } else {
            $this->tipodoc = $tipodoc;
        }
        return $this;
    }
    /**
     * Get serie value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerie()
    {
        return isset($this->serie) ? $this->serie : null;
    }
    /**
     * Set serie value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serie
     * @return \StructType\EditaSerieContrato
     */
    public function setSerie($serie = null)
    {
        // validation for constraint: string
        if (!is_null($serie) && !is_string($serie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($serie)), __LINE__);
        }
        if (is_null($serie) || (is_array($serie) && empty($serie))) {
            unset($this->serie);
        } else {
            $this->serie = $serie;
        }
        return $this;
    }
    /**
     * Get forceRefresh value
     * @return bool|null
     */
    public function getForceRefresh()
    {
        return $this->forceRefresh;
    }
    /**
     * Set forceRefresh value
     * @param bool $forceRefresh
     * @return \StructType\EditaSerieContrato
     */
    public function setForceRefresh($forceRefresh = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceRefresh) && !is_bool($forceRefresh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($forceRefresh)), __LINE__);
        }
        $this->forceRefresh = $forceRefresh;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EditaSerieContrato
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
